
SCR # 1
( String Routines:  $CONSTANT  $VARIABLE )       ( 051584 amf )

: $CONSTANT    ( $addr --        :@ compile
                       -- $addr  :@ runtime )
    CREATE  DUP C@ >R  R@ C,     ( Make header, store max cnt )
       HERE R@ 1+ CMOVE          ( Move string past header )
       R> 1+ ALLOT  ?ALIGN       ( Move DP past string, align )
    DOES>  1+  ;                 ( Skip max cnt on execution )

: $VARIABLE    ( #bytes --       :@ compile
                        -- $addr :@ runtime )
    CREATE  DUP C,  0 C,         ( Store max cnt, set to null )
       ALLOT   ?ALIGN            ( Allot max cnt bytes, align )
    DOES>  1+  ;                 ( Skip max cnt on execution )

DECIMAL -->

SCR # 2
( Strings cont:  $!  $TOPAD )                    ( 051684 amf )

: $!           ( $from/$to --  )
    DUP 1- C@                    ( Destination max byte count )
    3 PICK C@                    ( Source string length )
    MIN                          ( Clip to max cnt )
    OVER >R DUP >R               ( Save new length and $address)    1+ CMOVE                     ( Move source to destination )
    R> R> C!  ;                  ( Set length byte )

: $TOPAD       ( $addr -- PAD  :Move string to PAD if not there)    DUP PAD = NOT IF             ( At PAD already? )
       PAD $!  PAD               ( If not, move it there )
    THEN  ;

DECIMAL -->

SCR # 3
( Strings cont:  $+ )                            ( 051684 amf )

: $+           ( $addr1/$addr2 -- PAD )
    SWAP DUP PAD = NOT IF        ( Is $1 at PAD? )
       $TOPAD DROP               ( If not, move it there )
    ELSE
       DROP                      ( Otherwise we're ok )
    THEN
    PAD DUP C@ 1+ + SWAP         ( Find the end of $1 )
    PAD 256 +  3 PICK -  OVER C@ MIN      ( How much to move )
    >R  1+ SWAP R@ CMOVE         ( Move $2 onto end of $1 )
    R>  PAD C@ +  PAD C!  PAD ;  ( Update length, leave $addr )

DECIMAL -->

SCR # 4
( Strings cont:  RIGHT$  LEFT$  $. )   HEX       ( 051684 amf )

: RIGHT$       ( $addr/n -- PAD )
    SWAP $TOPAD                  ( Move it to PAD )
    OVER  PAD C@  < IF           ( Make sure n < string length )       OVER  PAD COUNT  + SWAP -      ( Get start addr of sub$ )       PAD 1+  4 PICK  CMOVE  C!  PAD     ( Move sub$ to PAD+1 )    ELSE
       SWAP DROP                 ( If n > $length, leave $addr )    THEN  ;

: LEFT$        ( $addr/n -- PAD )
    SWAP $TOPAD  C@ MIN  PAD C!  PAD  ;  ( You figure it out...)
: $.   ( $addr --  )   COUNT TYPE  ;
-->

SCR # 5
( Strings cont:  MID$  LEN )                     ( 051684 amf )

: MID$         ( $addr/startpos/#chr -- PAD )
    ROT $TOPAD               ( Move to PAD )
    C@  3 PICK -  0<         ( Check if startpos > $length )
    3 PICK 0=  OR            ( Or startpos = 0 )
    OVER 0=  OR  IF          ( Or #chr = 0 )
       2DROP  0 PAD C!       ( If so, leave null string )
    ELSE                     ( Clip #chr to $length - startpos )       OVER  PAD C@ 1+  SWAP - MIN
       SWAP PAD +  OVER PAD 1+ SWAP  CMOVE ( Move sub$ to PAD+1)       PAD C!                ( Set new length )
    THEN   PAD  ;

: LEN   ( $addr -- len )   C@  ;
-->

SCR # 6
( Strings cont:  ASC  NUL$  CHR$ )               ( 051684 amf )

: ASC          ( $addr -- n )
    DUP C@ IF
       1+ C@
    ELSE
       ." NULL STRING "  DROP 0
    THEN  ;

: NUL$   ( $addr --  )   0 SWAP C!  ;

: CHR$         ( n -- PAD )
    PAD 1+ C!  1 PAD C!  PAD  ;

-->

SCR # 7
( Strings cont:  $COMPARE  VAL )    HEX          ( 051684 amf )

: $COMPARE     ( $addr1/$addr2 -- flag )
    OVER C@  OVER C@  2DUP - >R    ( Save length difference )
    MIN  ROT 1+   ROT 1+  ROT SWAP  -TEXT    ( Compare $s )
    ?DUP 0= IF                     ( If they are the same... )
       R> DUP IF                   (  and they differ in length)          0< IF -1 ELSE 1 THEN     ( Leave sign of difference )
       THEN
    ELSE
       R>DROP                      ( Else leave -TEXT flag )
    THEN  ;

: VAL          ( $addr -- n )
    $TOPAD  PAD NUMBER  ;          ( Convert it to a number! )
-->

SCR # 8
( Strings cont:  <$  $=  $>  STR$ )   HEX        ( 051684 amf )

: $<   $COMPARE 0<  ;

: $=   $COMPARE 0=  ;

: $>   $COMPARE 0>  ;

: STR$         ( n -- PAD )
    DUP ABS  <# #S              ( Save sign, convert unsigned #)    SWAP  0< IF 2D ELSE 20 THEN  HOLD  #>     ( Minus or space )    >R  PAD 1+ R@ CMOVE         ( Move string to PAD )
    R> PAD C!  PAD  ;           ( Set max cnt byte )

-->

SCR # 9
( Strings cont:  POS$  INPUT$ )                  ( 051684 amf )

: POS$         ( $substring/$dest -- pos )
    DUP >R                            ( Save destination $addr )    COUNT  ROT COUNT DUP >R  MATCH    ( Save substring length )
    SWAP 0= IF                        ( 0 if match )
       R> -  R> -               ( Subtract substring length $ )
    ELSE                        (   dest $addr to get offset )
       R>DROP R>DROP DROP 0     ( Else leave no match flag )
    THEN  ;

: INPUT$       ( $addr --  )
    PAD 255 INPUT.STRING        ( Input maximum length string )
    DUP 1- C@  PAD C@  MIN PAD C!  ( Clip input string length )
    PAD SWAP $!  ;              ( Move input to destination $ )


XA 4: 